


_CountY 	BYTE	0
_CountX 	BYTE	0


_DrawBigLoop
	;
	; Init base/current screen adress
	;
	ldx	#0			; Current Y position
	lda	_ScreenPtrLow,x
	sta	tmp0+0
	lda	_ScreenPtrHigh,x
	sta	tmp0+1

	lda	#LOW(_StorageArea)
	sta	tmp1+0
	lda	#HIGH(_StorageArea)
	sta	tmp1+1

	;
	; Init X counter value
	;
	lda	#200
	sta	_CountY
y_draw_loop
	ldx	#0
	lda	#0
	sta	__y_patch+1
__y_patch
	ldy	#0
	inc	__y_patch+1
	cpy	#16			 ; Last cell reached
	beq	exit_loop
	lda	(tmp1),y
	bmi	_EraseLine		 ; Bit 7 defines FILLED/EMPTY

	;
	; Trace le segment horizontal
	;
_DrawLine
	sta	_CountX
draw_loop
	ldy	_Div6,x
	lda	(tmp0),y		; Old screen value
	eor	_Mod6,x
	sta	(tmp0),y		; New screen value

	inx
	dec	_CountX
	bne	draw_loop
	beq	__y_patch

_EraseLine
	and	#127
	beq	exit_loop		; Empty cell find
	sta	_CountX
	txa
	clc
	adc	_CountX
	tax
	jmp	__y_patch


exit_loop

	;
	; Incremente la Draw Table
	;
	clc
	lda	tmp1
	adc	#16
	sta	tmp1
	lda	tmp1+1
	adc	#0
	sta	tmp1+1

	;
	; Et l'adresse d'affichage
	;
	clc
	lda	tmp0
	adc	#40
	sta	tmp0
	lda	tmp0+1
	adc	#0
	sta	tmp0+1

	;
	; Next column
	;
	dec	_CountY
	bne	y_draw_loop

	;jmp	 _DrawBigLoop
	rts






_DIV6	BYTE	0
_MOD6	BYTE	0


_ComputeDivMod
	lda	#0
	sta	_DIV6
	sta	__ptr_div6+1
	sta	__ptr_mod6+1

	lda	#1
	sta	_MOD6



	lda	#32	; mod 6
	ldx	#0	; div 6
loop_div

__ptr_div6
	stx	_Div6		; Store Div6
	inc	__ptr_div6+1	; Increment low byte of adress

__ptr_mod6
	sta	_Mod6		; Store Mod6
	inc	__ptr_mod6+1	; Increment low byte of adress

	beq	quit_loop_div	; roll-over, means 256 byte copied

	;
	; Update Div/Mod
	;
	lsr	a
	;cmp	 #32
	bne	loop_div
	lda	#32
	inx
	bne	loop_div

quit_loop_div



	ldx	#200
loop_screen_offset
src_1
	lda	#$00
dst_1
	sta	_ScreenPtrLow
src_2
	lda	#$a0
dst_2
	sta	_ScreenPtrHigh

	clc
	lda	src_1+1
	adc	#40
	sta	src_1+1
	lda	src_2+1
	adc	#0
	sta	src_2+1

	inc	dst_1+1
	inc	dst_2+1

	dex
	bne	loop_screen_offset

	rts


	RESERVE 256- (* AND 255)

_Div6		RESERVE 256
_Mod6		RESERVE 256
_ScreenPtrLow	RESERVE 256
_ScreenPtrHigh	RESERVE 256

